#pragma once
#include <iostream>
#include <iomanip>
#include <fstream>
#include <ctime>
#include <vector>
#include <algorithm>
#include <iterator>
#include <string>
#include <cmath>

#define N 100
bool createData(const std::string& fileName) {
	srand(time(nullptr));
	std::ofstream fout(fileName, std::ios::out | std::ios::trunc);
	if (!fout) {
		throw std::exception("Wrong (file name is not valid)!");
		return false;
	}
	for (int i = 0; i < N; ++i) {
		fout << rand() % 101 - 50 << "\n";
	}
	fout.close();
	return true;
}


     
bool createDataGenerate(const std::string& fileName) {
	srand(time(nullptr));
	std::ofstream fout(fileName, std::ios::out | std::ios::trunc);
	std::vector<int> values(N);
	if (!fout) {
		throw std::exception("Wrong (file name is not valid)!");
		return false;
	}
	std::generate(values.begin(), values.end(), []() { return (std::rand() % 101 - 50); });
	std::copy(values.begin(), values.end(), std::ostream_iterator<int>(fout, "\n"));
	fout.close();
	return true;
}

template<class container>
std::vector<container>loadData (const std::string& file)
{
	std::vector<container> result;
	std::ifstream fin(file);

	if (!fin.is_open())
	{
		throw std::exception("Wrong (file name is not valid)!");
	}
	int readBuf;
	while (fin >> readBuf)
	{
		result.push_back(readBuf);
	}
	fin.close();

	return result;
};
template<class container>
std::vector<container> loadDataIterator(const std::string& fileName) {
	std::vector<container> result(N);
	std::ifstream fin(fileName);
	if (fin) {
		std::copy(std::istream_iterator<container>(fin), std::istream_iterator<container>(), result.begin());
	}
	return result;
}
//  9
template<class container>
bool Modify1( std::vector<container>&cont) {
	if (cont.size() == 0) {
		return false;
	}
	container firstUneven = 0;
	container sum = 0;
	for (const auto& i : cont) {
		if (i % 2 != 0) {
			firstUneven = i;
			break;
		}
	}
	container sum2 = 0;
	for (auto& i : cont) {
		i += firstUneven;
		sum+=i;
		sum2 += std::abs(i);
	}

	cont.push_back(sum);
	cont.push_back(sum2/100);
	return true;
}

template<class container>
bool Modify2(container beg, container end) {
	if (end == beg) {
		return false;
	}
	typename container::value_type firstUneven = 0;
	typename container:: value_type sum = 0;
	for (const auto& iter = beg; iter != end; ++iter) {
		if ((*iter) % 2 != 0) {
			firstUneven = *iter;
			break;
		}
	}

	for (auto& iter = beg; iter != end; ++iter) {
		*iter += firstUneven;
	}

	return true;
}

template<class container>
bool Modify3(std::vector<container>& cont) {
	if (cont.end() == cont.begin()) {
		return false;
	}

	auto firstUneven = std::find_if(cont.begin(), cont.end(), [](container i) { return i % 2 != 0; });
	if (!firstUneven) *firstUneven = 0;
	std::for_each(cont.begin(), cont.end(), [firstUneven](auto& obj) { obj += *firstUneven; });

	return true;
}

bool Modify4(const std::string& fileName) {

	std::vector<int> buffer(N);
	std::ifstream fin(fileName);
	if (!fin) {
	throw std::exception("Wrong (file name is not valid)!");
	}
	std::copy(std::istream_iterator<int>(fin), std::istream_iterator<int>(), buffer.begin());
	auto firstUneven = std::find_if(buffer.begin(), buffer.end(), [](int i) { return i % 2 != 0; });
	std::ofstream fout("res.txt");
	std::transform(buffer.begin(), buffer.end(), std::ostream_iterator<int>(fout, "\n"),
		[ firstUneven](auto& obj) { return obj += *firstUneven; });

	return true;
}

template<class container>
bool outputResult(const std::string& fileName, const std::vector<container>& cont) {
	std::ofstream fout(fileName, std::ios::out | std::ios::trunc);
	if (!fout) {
		throw std::exception("Wrong (file name is not valid)!");
		return false;
	}
	for (int i = 0; i < cont.size(); ++i) {
		fout << cont[i] <<"\n";
	}
	fout.close();
	return true;
}
template<class container>
bool createDataGenerate(const std::string& fileName, const std::vector<container>& cont) {
	srand(time(nullptr));
	std::ofstream fout(fileName, std::ios::out | std::ios::trunc);
	if (!fout) {
		throw std::exception("Wrong (file name is not valid)!");
		return false;
	}
	std::copy(cont.begin(), cont.end(), std::ostream_iterator<int>(fout, "\n"));
	fout.close();
	return true;
}
